<?php
include_once 'path.php';

$stack 			= array();
$path 			= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE;

$isVersionedRestore = false;

$startManualTaskButtonPressed 	= false;
$cancelManualTaskButtonPressed 	= false;

if($_SESSION['validUser'] === true) {
	if(!empty($_POST)) {
		$jobType 		= $_POST['jobTypeManualTask'];
		$jobNameDir 	= "+ManualTask";
		$jobTypePath 	= Scheduler::$user_dir."$jobType";
		$jobNameDirPath = "$jobTypePath/$jobNameDir";

		if(isset($_POST["startManualTaskButton"]) && $_POST["startManualTaskButton"] == 'Yes') {
			$startManualTaskButtonPressed = true;
		} else if(isset($_POST["cancelManualTaskButton"]) && $_POST["cancelManualTaskButton"] == 'Yes') {
			$cancelManualTaskButtonPressed = true;
		}

		if($_POST['backupLocation'])
			update_mpc($_POST['backupLocation']);

		if(isset($_POST['restoreLocation']) && $_POST['restoreLocation']){
			$restoreLocation = phpRealEscapeString($_POST['restoreLocation']);
			file_put_contents($drlFile, $restoreLocation);
			@chmod($drlFile, $permissionVal);
		}

	   if($startManualTaskButtonPressed == true) {
			$_SESSION['jobNameManualTask'] 			= $jobNameDir;
			$_SESSION['jobNameDirPathManualTask'] 	= $jobNameDirPath;
			$directoryPath 							= 'dirPathsManualTask';

			unset($_SESSION[$directoryPath]);
			if (isset($_POST['chk_group'])){
				if (isset($_POST['vrn']) && !empty($_POST['vrn'])) {
					$isVersionedRestore = true;
					if (count($_POST['chk_group']) > 1) {
						$resp[] = false;
						$resp[] = "More than one file are not allowed.";
						echo json_encode($resp);
						exit;
					}
					$_POST['chk_group'][0] = ($_POST['chk_group'][0] . "_IBVER"  . trim($_POST['vrn']));
					$optionArray = $_POST['chk_group'];
				}
				else {
					$optionArray = $_POST['chk_group'];
				}
				for ($i=0; $i<count($optionArray); $i++){
					$optionArray[$i] = phpRealEscapeString($optionArray[$i]);
					$_SESSION[$directoryPath][$i] = $optionArray[$i];
				}
				
				$_SESSION['countAddDirsManualTask'] = count($optionArray);
			}
			
			$oldMask = umask(0);

			if(!file_exists($path)) {
				if(!mkdir($path, $permissionVal)) {
					$_SESSION['validUser'] = true;

					$resp = array(false, "Failed to create Directory $path : $php_errormsg");
					echo json_encode($resp);
					exit;
				}
			}

			if(!file_exists($jobTypePath)) {	
				if(!mkdir($jobTypePath, $permissionVal)) {
					$_SESSION['validUser'] = true;

					$resp = array(false, "Failed to create Directory $jobTypePath : $php_errormsg");
					echo json_encode($resp); 
					exit;
				}
			}
		
			if(!file_exists($jobNameDirPath)) {
				if(!mkdir($jobNameDirPath, $permissionVal)) {
					restartSession(); //Restart session

					$resp = array(false, "Failed to create Directory $jobNameDirPath : $php_errormsg");
					echo json_encode($resp);
					exit;
				}
			}

			umask($oldMask);

			if(($fHandle = fopen("$jobNameDirPath/$startPid", "w+"))){
				if (isset($_POST['vrn'])) {
					$versionData = array();
					$versionData['version'] = $_POST['vrn'];
					$versionData['file'] = preg_replace('/_IBVER(\d)+$/', '', $_POST['chk_group'][0]);
					$versionData['size'] = $_POST['vrs'];
					$versionData['modifiedon'] = $_POST['vrm'];
					fwrite($fHandle, serialize($versionData));
				}
				fclose($fHandle);
			}
			
			@chmod("$jobNameDirPath/$startPid", $permissionVal);
			
			if(strcmp($jobType, "Backup") === 0)
				$displayFile = "$jobNameDirPath/".BACKUPSETFILEDISPLAY;
			else
				$displayFile = "$jobNameDirPath/".RESTORESETFILEDISPLAY;
		
			if(file_exists($file)) {
				unlink($file); 
			}
			
			$displayFileHandle = fopen($displayFile, "w+");
			
			if($_SESSION['countAddDirsManualTask'] > 0) {	
				$itemType	= $_POST['itemType'];
				for($i = 0; $i < $_SESSION['countAddDirsManualTask']; $i++) {
					if($_SESSION['dirPathsManualTask'][$i] !== "") {
						fwrite($displayFileHandle, $_SESSION['dirPathsManualTask'][$i] . "\n" . $itemType[$i] . "\n");
					    array_push($stack, $_SESSION['dirPathsManualTask'][$i]);
				    }
			    }
		    }
			
			fclose($fileHandle);
			fclose($displayFileHandle);
			@chmod($displayFile, $permissionVal);

			if(strcmp($jobType, "Backup") === 0) {
				$_SESSION['currentBackupJob'] = $_POST['oldJobName'];
			} else {
				$_SESSION['currentRestoreJob'] = $_POST['oldJobName'];
			}
			
			scheduler::Log('Starting ' . $jobType . ': Manual Task');

			$cmd = perlScriptExecution($jobType."_Script_IDrive.pl", $jobNameDirPath, 0);
			pclose(popen("$cmd &", "r"));
			
			$resp = array(true, MANUAL_TASK_STARTED);
			echo json_encode($resp);
		} else if($cancelManualTaskButtonPressed) {
			if(($fHandle = fopen("$jobNameDirPath/".CANCEL_PATH, "w"))) {
				fclose($fHandle);
				@chmod("$jobNameDirPath/".CANCEL_PATH, $permissionVal);
			}
			
			$fullPathJobName 		= $jobNameDirPath;
			$jobTerminationStatus 	= perlScriptExecution(JOBTERMINATE, $fullPathJobName);

			scheduler::Log('Canceling the job');

			if(strcmp($jobType, "Backup") === 0) {
				$_SESSION['currentBackupJob'] = '';
			} else {
				$_SESSION['currentRestoreJob'] = '';
			}

			$resp	= array(false, MANUAL_TASK_STOPPED);
			echo json_encode($resp); 
		}
	}
} else {
	$destinationURL = "../index.php";
	header("Location:$destinationURL");
	exit();
}

?>
