/* Local Search - Start */
var searchAjaxCall='';
var searchResult=false;
// Search popup event
// contact Earlier  version popup
$(document).on('mousedown','.search_menu1',function(){
	jQuery('#searchError,#localDirSearchHeader').hide();
	
	//Clearing the array
	searchItemArray     = [];
	searchItemTempArray = [];
	searchItemTypeArray = [];	
	
	$.popContainer();
	cancelledSearch=false;
	$(secPosCont).append($('.search_popup').show());
	$(popcont).addClass('popLeft');	
	jQuery('.search_popup .nfiles').show().html('No Results');
	if(jQuery('.body_wrap').hasClass('backup_page')){
		jQuery('#localDirSearchList').html('');
		jQuery('#addToBackupSet').hide();
	} else {
		jQuery('#remoteDirSearchList').html('');
		jQuery('#addToRestoreSet').hide();
	}	
});

$(document).on('keyup','.search_input',function(e){
	if (e.keyCode == 13) {
	var element = jQuery(this).siblings('input');
		if (searchStarted == false) {
		  ((element.attr('id') == 'localSearch') ? startLocalSearch(): startRemoteSearch());
		}
		return false;
	}
});
$(document).on('mousedown','#remoteSearch',function(){
	startRemoteSearch();
	return false;
});

$(document).on('mousedown','#localSearch',function(){
	startLocalSearch();
	return false;
});

//Function to Start Remote Search
function startRemoteSearch(){
	searchKeyword = jQuery('input.search_input').val();	
	searchKeyword = searchKeyword.toLowerCase();
	var searchPath = $('#location_selected').text();           
	if(searchKeyword!=''){
		if(searchKeyword.indexOf('/')>=0 || searchKeyword.indexOf('\\')>=0){
			showErrorMessages('#searchError','Invalid search string. String should not contain "/" and "\\"');
			return false;
		}
		searchKeyword = searchKeyword.replace(/^\/+|\/+$/g, '');
		if(searchKeyword=='' || searchKeyword=='.'  || searchKeyword=='..'){
			showErrorMessages('#searchError','Please enter the valid search string');
			return false;
		}
		var values = "searchKeyword="+encodeURIComponent(searchKeyword)+"&searchPath="+encodeURIComponent(searchPath);
		jQuery('#rgt .backupset_table').html('');
		jQuery('#rgt .nfiles,.tab_loader,.disabled_search_btn').show();
		jQuery('.search_box_btn,#searchError').hide();
		searchStarted = true; //Flag to identify the Search process
		loadPage =2;
		searchResult=false;
		searchAjaxCall = $.ajax({
				url: "action.php?action=startRemoteSearch",
				type: "POST",
				data: values,
				success: function(responseData){
					if(responseData.indexOf('<html>')>0){
						window.location.href='../index.php';
					}					
				}
		});
		if(cancelledSearch==false){
			loadSearchTimout = setTimeout("getSearchResult('1','restore','0')",3000); //1000 = 1Sec
		}
	} else {
		showErrorMessages('#searchError','Please enter the search keyword');
	}
}

//Function to Start Local Search
function startLocalSearch(){
	searchKeyword = jQuery('input.search_input').val();	
	var searchPath = $('#location_selected').text();
	if(searchKeyword!=''){
		if(searchKeyword.indexOf('/')>=0 || searchKeyword.indexOf('\\')>=0){
			showErrorMessages('#searchError','Invalid search string. String should not contain "/" and "\\"');
			return false;
		}		
		searchKeyword = searchKeyword.replace(/^\/+|\/+$/g, '');
		if(searchKeyword=='' || searchKeyword=='.' || searchKeyword=='..'){
			showErrorMessages('#searchError','Please enter the valid search string');
			return false;
		}	
		jQuery('#rgt .backupset_table').html('');
		jQuery('#rgt .nfiles,.tab_loader,.disabled_search_btn').show();
		jQuery('.search_box_btn,#searchError').hide();
		var values = "searchKeyword="+encodeURIComponent(searchKeyword)+"&searchPath="+encodeURIComponent(searchPath);
		searchStarted = true; //Flag to identify the Search process
		loadPage =2;
		searchResult=false;
		//AJAX call to start Search
		searchAjaxCall = $.ajax({
			url: "action.php?action=startLocalSearch",
			type: "POST",
			data: values,
			success: function(responseData){
				if(responseData.indexOf('<html>')>0){
					window.location.href='../index.php';
				}				
				cmd = $.parseJSON(responseData);
				if(cmd[0]==true){
					if(cancelledSearch==false){
						loadSearchTimout = setTimeout("getSearchResult('1','backup','0')",3000); //1000 = 1Sec
					}
				} else {
					getSearchResult('1','backup','0');
				}
			}
		});
		
	} else {
		showErrorMessages('#searchError','Please enter the search keyword');
	}
}
function getSearchResult(page,type,count){
	var html='';
	var img,itemSize;
	localDirMore =false;
	abortAjax(searchAjaxCall); // Abort the Search request
	//AJAX call to get Search Result
	searchAjaxRequest2 = $.ajax({
		url: "action.php?action=getSearchRes&page="+page+"&type="+type+"&count="+count,
		success: function(locationData){
			if(locationData.indexOf('<html>')>0){
				window.location.href='../index.php';
			}			
			searchRes = $.parseJSON(locationData);
			if(searchRes[0]==1 && searchRes[3]>0){
				$.each(searchRes[2], function(i,res){
					if(sh=="Hide"){
						var mname=res.name;
						var pos=mname.indexOf("/.");
						if(pos>0 || pos==0){
							var tr_style='style="display: none;"';
                           return;
						} else {
							var tr_style='';
						}
					}
					else{
						var tr_style='';
					}
				
					img = res.type=='F'?'file':'folder';
					itemSize = res.type=='F'?res.size:'--';
					html +=  '<tr '+tr_style+'>';
					html +=  '<td class="search-chk-box file_check">\
						     <input type="checkbox" id="dir_elements['+i+']" name="dir_elements['+i+']" value="'+htmlEntities(res.name)+'"> <label>'+img+'</label></td>';
					html +=  '<td class="cont_heading search-file-name" title="'+htmlEntities(res.name)+'"><img src="include/images/idq_ico_'+img+'.png" >\
							 <span>'+htmlEntities(res.name).replace(/\s/g,'&nbsp;')+'</span></td>';
					html +=  '<td class="search-file-size">'+itemSize+'</td>';
					html +=  '<td class="search-file-date">'+res.date+'</td>';
					
						if(jQuery('#rgt .excludefiles').attr('id')=="remoteDirSearchList"){
							var tdClass = ' drop_list';
							jQuery('#rgt .backupset_table').addClass('restr');
						} else {
							var tdClass = '';
						}
					html +=  '<td class="search-menu-icon drop_list'+tdClass+'"></td>';
					html +=  '</tr>';
				});
				if(html!=''){ searchResult=true; } //Flag to confirm the result 
				html +=  '<tr class="search_loading"><td colspan="4">&nbsp;</td></tr>';
				localDirMore =true;
				jQuery('.tab_loader').hide();	
				jQuery('.backupset_table tr.search_loading').remove();
				if(page==1 && count==0){
					jQuery('#rgt .excludefiles').html('<table cellspacing="0" cellpadding="0" border="0" width="100%" class="folderBackupContent selectedFiles_tab backupset_table bc_table"><tbody></tbody></table>');
					jQuery('#rgt .nfiles,.disabled_search_btn').hide();
					jQuery('#rgt .menu,.search_box_btn,#rgt .header_part input').show();
					jQuery('#rgt .header_part td:first').removeClass('file_check_disabled').addClass('file_check');
				}
				jQuery('#rgt .backupset_table').append(html);
				
				if(jQuery('#rgt .excludefiles').attr('id')=="remoteDirSearchList"){
					jQuery('#rgt .backupset_table').addClass('restr');
				}	
				if(searchRes[1]<400){
					jQuery('.backupset_table tr.search_loading').show();
					loadSearchTimout = setTimeout("getSearchResult('"+page+"','"+type+"','"+searchRes[1]+"')",10000); //1000 = 1Sec
					localDirMore =false;
				}
			} 
			else if((searchRes[0]==1)) {
				localDirMore =false;
				loadSearchTimout = setTimeout("getSearchResult('"+page+"','"+type+"','"+searchRes[1]+"')",5000); //1000 = 1Sec				
			}			
			else if(searchRes[0]==0) {
				jQuery('#rgt .backupset_table tr.search_loading').remove();
				if((page==1 && count==0) || searchResult==false){
					var nofile = "<b>No items match your search.</b><br><br>Change search term and try again."
					jQuery('.tab_loader').hide();
					jQuery('#rgt .nfiles').show().html(nofile);
					jQuery('#rgt .backupset_table').html('');
					jQuery('#rgt .menu,.disabled_search_btn').hide();	
					jQuery('.search_box_btn').show();
				}
				searchStarted = false;
				localDirMore =false;
			}
		}
	});
}

function ViewportDetect(el) {
    var rect = el.getBoundingClientRect();
    return rect.bottom > 0 && rect.top < (window.innerHeight || document.documentElement.clientHeight);
}

function onScrollForLocal(){
	jQuery("#localDirSearchList").on("scroll", function() {
		jQuery('tr.search_loading').show();
		if(localDirMore==true){	
			localDirMore = false;
			if(ViewportDetect(document.getElementsByClassName("search_loading")[0])){				
				getSearchResult(loadPage,'backup','0');
				loadPage++;
			} else {
				localDirMore = true;
			}
			
		}	
	});
}

function onScrollForRemote(){
	jQuery("#remoteDirSearchList").on("scroll", function() {
		jQuery('tr.search_loading').show();
		if(localDirMore==true){
			localDirMore = false;
			if(typeof document.getElementsByClassName("search_loading")[0]!='undefined' && ViewportDetect(document.getElementsByClassName("search_loading")[0])){
				getSearchResult(loadPage,'restore','0');
				loadPage++;
			} else {
				localDirMore = true;
			}
		}
	});
	
}

//Function to add local folder/file to backup set
$(document).on('click','#addToBackupSet',function(){
	if(searchItemArray.length>0){
		searchItemTempArray = keepParentInsteadChild(searchItemTempArray);
		var data = searchItemTempArray.filter(function(selectedItem){
			var isParent = checkParentOnBackupSet(selectedItem,'backup');
			if(isParent==true){
				backupSetFiles(selectedItem);
			}			
		});
		if($("#fullPathBreadCrumb a").length>1){
			$("#fullPathBreadCrumb a:last").trigger("click");
		} else {
			markSelectedJobItems('backup');
			jQuery('#fullPathBreadCrumb a:last').trigger("click");
		}
		$(".closeWin").trigger("click");
		actionRequired=2;
	} else {
		showErrorMessages('#searchError',"Please select files/folders to add into backup set");
		return false;
	}	
	if(jQuery('#select_job').val()!=0){
		startTimeoutForAutoPost('backup');
	}
});
//Function to add local folder/file to backup set
$(document).on('click','#addToRestoreSet',function(){
	if(searchItemArray.length>0){
		searchItemTempArray = keepParentInsteadChild(searchItemTempArray);
		var data = searchItemTempArray.filter(function(selectedItem){			
			var isParent = checkParentOnBackupSet(selectedItem,'restore');
			if(isParent==true){				
				restoreSetFiles(selectedItem);
			}				
		});		
		if($("#fullPathBreadCrumb a").length>1){
			$("#fullPathBreadCrumb a:last").trigger("click");
		} else {
			markSelectedJobItems('restore');
			$("#fullPathBreadCrumb a:last").trigger("click");

		}
		$(".closeWin").trigger("click");
		actionRequired=2;
	} else {
		showErrorMessages('#searchError',"Please select files/folders to add into restore set");
		return false;
	}
	if(jQuery('#select_restore_job').val()!=0){
		startTimeoutForAutoPost('restore');
	}
});
//Cancel the Search
$(document).on('click','.search_popup .popup_cancelBtn,.search_popup .popup_close_btn',function(){
	cancelledSearch=true;
	$.popContainerHide();
	toResetForm();	
	jQuery('.search_popup .nfiles').show();
	if(jQuery('.body_wrap').hasClass('backup_page')){
		jQuery('#localDirSearchList').html('');
		jQuery('#rgt .menu').hide();
		stopSearchExecution('backup');
	} else {
		jQuery('#remoteDirSearchList').html('');
		jQuery('#rgt .menu').hide();
		stopSearchExecution('restore');
	}	
});
//Stop the execution of Search
function stopSearchExecution(type){
	if(searchStarted == true){
		localDirMore = true;
		abortAjax(searchAjaxCall);      // Stop the "search command" AJAX request
		abortAjax(searchAjaxRequest2);  // Stop the "get search result" AJAX request
		clearTimeout(loadSearchTimout); // Clear the "get search page result" timer
		
		//Clear the selected search item array
		searchItemArray     = []; 
		searchItemTempArray = [];
		searchItemTypeArray = [];	
		
		jQuery('.tab_loader').hide();
		var values = "&searchKeyword="+encodeURIComponent(searchKeyword);
		//AJAX call to stop the execution of Search
		$.ajax({
			url: "action.php?action=stopSearch&type="+type+values,
			success: function(locationData){
				if(locationData.indexOf('<html>')>0){
					window.location.href='../index.php';
				}				
				//Success message
			}
		});
		searchStarted = false; //Flag to identify the Search process
	}
}
function checkParentOnBackupSet(selected,type){	
	if(type=='backup'){
		var backupArray1 = backupSetArray;
	} else {
		var backupArray1 = restoreSetArray;
	}
	
	var isParent1 = array_search_reverse(backupSetArray,selected);
	if(isParent1==''){
		return true;
	} else {
		return false;
	}	
}
/* Local Search - End */

$(document).on('click','#rgt td.file_check,#rgt .header_part .file_check',function(e){
	//Checking whether clicked on Checkbox or TD
	var clickedLabel = e.target.nodeName;	
	if(clickedLabel != 'LABEL'){		
		return false;
	}
	
	if(jQuery(this).find('label').hasClass('label_checked')){
		if(jQuery(this).find('label').html()=="All"){			
			addSearchFiles("All");
		} else {		
			addSearchFiles(jQuery(this));
		}

	}  else {
		if(jQuery(this).find('label').html()=="All"){			
			removeSearchFiles("All");
		} else {				
			removeSearchFiles(jQuery(this));
		}

	}		
	return false;		
});



/* Function to add selected elements to search array */
function addSearchFiles(args){
	var html = '', selected='';
	
    /* Add selected files/folders under search array to add into Backup/Restore Set - Start */
	if(args=="All"){
	  jQuery('#rgt .backupset_table input').each(function(){
		selected = jQuery(this).val();
		var imgSrc = jQuery(this).parent().next().find('img').attr('src');
		var imgSubstr = imgSrc.substring(23);
		var itemType = imgSubstr.replace('.png','');
		
		if(searchItemArray.indexOf(selected)==-1){
			searchItemArray.push(selected);			
			searchItemTempArray.push(selected);
			searchItemTypeArray.push(itemType);			
		}
	  });
	  
	} else {
		selected = args.find('input').val();
				
		var imgSrc = args.next().find('img').attr('src');
		var imgSubstr = imgSrc.substring(23);
		var itemType = imgSubstr.replace('.png','');
		if(searchItemArray.indexOf(selected)==-1){			
			searchItemArray.push(selected);			
			searchItemTempArray.push(selected);
			searchItemTypeArray.push(itemType);
		}
	}
}

/* Function to remove selected elements from Backup Set */
function removeSearchFiles(args){
	if(args=="All"){			
		searchItemArray     = [];
		searchItemTempArray = [];
	    searchItemTypeArray = [];
	} else {
		selected = args.find('input').val();
		var index = searchItemArray.indexOf(selected);
		if(index>=0){
			searchItemArray.splice(index, 1);
			searchItemTempArray.splice(index, 1);
			searchItemTypeArray.splice(index, 1);
		}		
	}
}

$(document).ready(function(){
	var pHeight = $(window).innerHeight();		
	$(".serverDts").css("height", pHeight);
	$(".serverDts .excludefiles").css("height", pHeight-190);
});
$(window).resize(function(){
	var pHeight = $(window).height();
	$(".serverDts").css("height", pHeight);
	$(".serverDts .excludefiles").css("height", pHeight-190);
});
$(document).on("click",".search_menu",function(){
	$('#location_selected').text('/').attr('title', '/');
	var pHeight = $(window).innerHeight();		
	$(".serverDts").css("height", pHeight);
	$(".serverDts .excludefiles").css("height", pHeight-190);
		jQuery('#searchError,#rgt .menu,.disabled_search_btn').hide();
		jQuery('.search_input').val('').focus();
		//Clearing the array
		searchItemArray     = [];
		searchItemTempArray = [];
		searchItemTypeArray = [];		
		cancelledSearch=false;		
		loadPage=1;
		jQuery('#rgt .nfiles').show().html('<b>No Results</b>');
		jQuery('#rgt .menu,#rgt .header_part input').hide();
		jQuery('#rgt .header_part td:first').removeClass('file_check').addClass('file_check_disabled');
		if(jQuery('.body_wrap').hasClass('backup_page')){
			jQuery('#localDirSearchList').html('');			
		} else {
			jQuery('#remoteDirSearchList').html('');
		}	
		
		$(".serverDts").animate({right:'0px'},{ duration: 500, queue: false });
		$('.errorContent,.search_box_btn').css('display', 'block');
		$('body,html').css('overflow','hidden');
});
	
	$(document).on("click",".closeWin",function(){
		$(".serverDts").animate({right:'-800px'},{ duration: 500, queue: false });	
		$('body,html').css('overflow','auto');
		cancelledSearch=true;
		jQuery('#rgt .nfiles').show();
		jQuery('#rgt .menu,#rgt .header_part input').hide();
		jQuery('#rgt .header_part td:first').removeClass('file_check').addClass('file_check_disabled');
		jQuery('.currentLoad input#mainchek').removeAttr('checked').siblings('label').removeAttr('class');
		if(jQuery('.body_wrap').hasClass('backup_page')){
			jQuery('#localDirSearchList').html('');			
			stopSearchExecution('backup');
		} else {
			jQuery('#remoteDirSearchList').html('');
			stopSearchExecution('restore');
		}		
	});			 
		 
	$(document).on('mouseup', function (e){
		if(jQuery('.serverDts ').css('right')=='0px'){
			var OutSideClick = $(".search_menu,.serverDts");  
			var OutSideClickRename = $(".file_menu_details, .file_menu_rename, .file_menu_share, .file_menu_version, .file_menu_search"); //search-menu-icon drop_list
			var exclude_list_menu = $(".exclude_list");

			if(e.target.nodeName!='IMG'){
				if (!OutSideClick.is(e.target) && !OutSideClickRename.is(e.target) && !exclude_list_menu.is(e.target) && OutSideClick.has(e.target).length === 0){
					$(".closeWin").trigger("click");
				}
			}
		}
	});	   
	   
$(document).on('mousedown','#localDirSearchList tr,#remoteDirSearchList tr', function(e) {
	if( (e.which == 3) ) {
		$(this).addClass('rgtclk chk');
		$(this).find('label').addClass('label_checked');
		$(this).find('input[type=checkbox]').attr('checked',true);
	}
});


function keepParentInsteadChild(arr){
	arr.sort(function(a, b){
	  return a.length - b.length; // ASC -> a - b; DESC -> b - a
	});
	var arrTemp = arr.slice(0);
	var i=0;
	var matches = arrTemp.filter(function(str) {
		var j=i+1;
			if(arrTemp.length-1<=j){
				return;
			} 
		var matches1 = arrTemp.filter(function(str) {
			if(arrTemp[j].indexOf(arrTemp[i]) != "" && arrTemp[j].indexOf(arrTemp[i]) != null)
			{
				isInString = (arrTemp[j].indexOf(arrTemp[i]) == 0);
				if(isInString===true){
					
					if(arrTemp.indexOf(arrTemp[j]) != "" && arrTemp.indexOf(arrTemp[j]) != null)
					{
						var index = arrTemp.indexOf(arrTemp[j]);
						arrTemp.splice(index, 1);
					}
				}
				if(arrTemp.length-1>j){
					j++;
				} else { return; }
			}
		});
		i++;
	});
	return arrTemp;
}

