<?php
include_once 'path.php';
if(!isset($_SESSION['validUser']) || $_SESSION['validUser'] !== true)
	exit(header("Location:../index.php"));

if(isset($_SESSION['userName']) && ($_SESSION['userName'] != '')) {
	$rListPath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/.RestoreList";

	if(is_dir($rListPath)) {
		file_put_contents($temp_file, DIRREMOVE);
		@chmod($temp_file, $permissionVal);
		perlScriptExecution(OPERATIONSFILE, Scheduler::$user_dir);
	}

	clearStartPid(Scheduler::$backup_dir);
	clearStartPid(Scheduler::$restore_dir);
	clearPid(Scheduler::$archiveclean_dir);
	clearPid(Scheduler::$delete_dir);
	cancelJobAfterTerminate(Scheduler::$backup_dir);
	cancelJobAfterTerminate(Scheduler::$restore_dir);
	
	$file = Scheduler::$user_dir.SERVER_ADDR_PATH;
	if(file_exists($file))
		unlink($file);
	unset($_SESSION['serverAddr']);
    getEVSServerAddr();

	autoUpdateBackupset();
	excludeworkingfolder();
	migrate();
} else {
	$userName='';
	unset($_SESSION['configVerified']);
	unset($_SESSION['encType']);
	unset($_SESSION['userName']);
	unset($_SESSION['password']);
}

machineBasedContent($machine);

$js_version = trim(preg_replace('/[a-zA-Z]+/', '', $appVersion));

$checkUpdate = checkAppUpdate();
unset($_SESSION['sharedDirectoriesRaw']);
?>
<!doctype html>
<html>
<head>
      <meta charset="UTF-8">
      <title><?php print $appMetaTitle;?></title>
      <link href="include/css/qnap_layout.css?ver=<?php echo $js_version;?>" type="text/css" rel="stylesheet" />
	  <link href="include/css/<?php print $appThemeCSS;?>?ver=<?php echo $js_version;?>" type="text/css" rel="stylesheet" />
	  <link href="include/css/search_ui.css?ver=<?php echo $js_version;?>" type="text/css" rel="stylesheet" /> 	  
      <link rel="icon" href="include/images/<?php print $appFavicon;?>" sizes="16x16" />
      <link rel="shortcut icon" href="include/images/<?php print $appFavicon;?>" type="image/x-icon" />
	  <script src="include/scripts/1.7.2.jquery.min.js" type="text/javascript"></script> 
		<script src="./constants-js.php?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	  	<script src="include/scripts/checkbox.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
		<!-- <script src="include/scripts/ContextMenu.js" type="text/javascript"></script> -->
		<!--[if IE 8]>  <link href="include/css/ie8.css?ver=<?php echo $js_version;?>" rel="stylesheet" type="text/css" /> <![endif]-->
		<!--[if lte IE 7]>  <link href="include/css/ie7.css?ver=<?php echo $js_version;?>" rel="stylesheet" type="text/css" /> <![endif]-->
		<!--[if IE]> <script src="https://html5shim.googlecode.com/svn/trunk/html5.js"></script> <![endif]-->
        <script>
			// Declaring IDrive object, added by sreenath on 01-04-2014
			var IDrive = {};
		    $.get("action.php?action=getSharedList");			
		</script>
	<?php checkShowHidden(); ?>
</head>
<body>
      <section class="body">
		<div id="page_loader" class="page_loader" style="display:block;"><p>loader...</p></div>
         <div class="wrapper">
         <header>
            <h1><a class="<?php print $logoClassName; ?>" target="_blank" href="https://www.idrive.com/"><?php print $appMetaTitle;?></a><p class="version"><span class="version-no"><?php print $appVersion;?></span>
			<?php		
			if(trim($checkUpdate)=='Y') {
			?>
				<span class="update-btn" title="<?php print $appUpdateMsg; ?>"><a  href="<?php print $appUpdateURL; ?>" <?php print ($machine=='twotier')?'':'target="_blank"'; ?>></a></span>
			<?php }	?>
			</p></h1>
            <section class="head_cont">
               <div class="head_links">
                  <ul>
                     <li><a target="_blank" href="upgrade.php" id="toplink_upgrade">Upgrade</a></li>
                     <li class="head_usercont"> <a class="head_user">
						<?php
						if($userName!='' && isset($_SESSION['encType']) && isset($_SESSION['configVerified'])){
						  print $getUserName = $userName;
						} else {
						   $getUserName = '';
						  print GUEST_USER;
						}			 	
						?>
						</a><span id='registered_user' style="display:none;"><?php print $getUserName; ?></span>
						<div class="sliding">
                           <ul>
                              <li><a href="account.php" class="topnavbutton" alt="<?php print $machine=='twotier'?TWOTIER_ACCOUNT_TITLE:ACCOUNT_TITLE; ?>">My Account</a></li>
                              <li><a href="preferences.php" class="topnavbutton" alt="<?php print PREFERENCES_TITLE; ?>"><?php echo PREFERENCES_TITLE; ?></a></li> 
							  <li><a href="#" id="sendErrLink" class="topnavbutton1">Send Error Report</a></li>
							  <li><a href="<?php print $appHelpLink;?>" alt="Help" target="_blank">Help</a></li>								
                              <li><a href="logout.php">Logout</a></li>
                           </ul>
                        </div>
                     </li>
                  </ul>
               </div>
               <div class="head_search">
                  <div class="common_msg error_msg"  <?php print $getUserName!=''?'':'style="display: block;"' ?>>
                     <p id="errorMsg"><?php print GUEST_USER; ?></p>
                     <a href="javascript:void(0)" class="close_info"><img width="16" height="16" title="Close" alt="close" src="include/images/close.png"></a>
                  </div>
                  <div class="common_msg alert" tabindex="100">
                     <p>Loading........Please wait</p>
                     <a href="javascript:void(0)" class="close_info"><img width="16" height="16" title="Close" alt="close" src="include/images/close.png"></a>
                  </div>
                  <div class="common_msg welcome_message">
                     <p>Welcome</p>
                     <a href="javascript:void(0)" class="close_info"><img width="16" height="16" title="Close" alt="close" src="include/images/close.png"></a>
                  </div>
                  <div class="float_lt page_title">
                    <h4>
						<?php 
							if($getUserName!='')
								print BACKUP_TITLE;
							else
								print $machine=='twotier'?TWOTIER_ACCOUNT_TITLE:ACCOUNT_TITLE;			
						?>
					</h4>
                  </div>
                  <div class="storage_used">
                    <?php 
						if($getUserName!=''){
							include("accountUsage.php"); 
						}
					?>
                  </div>
               </div>
            </section>
         </header>
         <section class="leftnav">
            <ul>
               <li><a href="backup.php" id="nav_backup" class="leftnavbutton<?php print $getUserName!=''?' act':'' ?>" alt="<?php print BACKUP_TITLE; ?>">Backup</a></li>
               <li><a href="restore.php" class="leftnavbutton" id="nav_restore" alt="<?php print RESTORE_TITLE; ?>">Restore</a></li>
               <li><a href="scheduler.php" id="nav_scheduler" class="leftnavbutton" alt="<?php print $machine=='twotier'?TWOTIER_SCHEDULER_TITLE:SCHEDULER_TITLE; ?>">Scheduler</a></li>
               <li><a href="logs.php" class="leftnavbutton" id="nav_log" alt="<?php print LOGS_TITLE; ?>">Log</a></li>
            </ul>
			<div class="next_scheduled_event" style="top: auto; bottom: 5px; position: fixed; display: none;" id="nse_main_div">
				<hr>
				<p>Next Scheduled Event </p>
				<a href="#" class="evnet_status" id="nse_jobname"></span></a>
				<a href="#" class="evnet_status" id="nse_jobtime"></span></a>
				<input type="hidden" id="nse_real_event" />
				<hr>
			</div>
			</section>		 
         <!-- content: -->
         <section id="content" class="content" style="<?php print $getUserName!=''?'margin-top:125px;':'margin-top:167px;' ?>" >
	  <?php 
		if($getUserName!=''){
			include("backup.php"); 
		} else {
			include("account.php"); 
		}
	  ?>
         </section> <!-- /content -->
         <footer>&copy; IDrive Inc.</footer>
         </div>
      </section>   
	  <div class="container-time-wrap">
		<div class="device-time-wrap" style="width: auto;">
			<div class="time-clock">
				<ul id="clock">
					<li id="sec" style="transform: rotate(324deg);"></li>
					<li id="hour" style="transform: rotate(456deg);"></li>
					<li id="min" style="transform: rotate(72deg);"></li>
				</ul>
			</div>
			<div class="time-innerwrap" style="width: 0px;">
				<p class="heading_time">Time on Device:</p>
				<p class="time-disp"> <span class="hours-disp">06</span> <span class="colon-disp">:</span> <span class="minutes-disp">08</span> <span class="meridiem-disp">PM</span> </p>
				<p class="current-date-wrap"> <span class="day-disp">Wed</span>, <span class="month-disp">Aug</span> <span class="date-disp">26</span> <span class="year-disp">2015</span> </p>
			</div>
			<div class="time-arrow">
				<a class="slide-arrow-open slide-arrow-close"></a>
			</div>
		</div>
	</div>
	<script type="text/javascript" src="include/scripts/jquery.trackbar.js"></script>
	<script src="include/js/backup.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	<script src="include/js/custom.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	<script src="include/js/scheduler.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	<script src="include/js/accountValidation.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	<script src="include/scripts/popupScript.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	<script src="include/js/restore.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	<script src="include/js/preferences.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	<script src="include/js/search.js?ver=<?php echo $js_version;?>" type="text/javascript"></script>
	<script>
		var machine='<?php print $machine;?>';
		var sharedFolderPath='<?php print TWOTIER_SHARED_PATH;?>';
		var sharedFolderPathLength = sharedFolderPath.length-1;
		var vaultRestorePath='<?php print IDRIVE_VAULT_RESTORELOCATION_ROOT;?>';
		var workingFolderValue = '<?php print getOriginalServicePath();?>';
		var backupModeSet = '<?php print getBackupMode();?>';
		var workingFolderType  = 'folder';
				
		jQuery(document).ready(function(){
			jQuery('#page_loader').hide();
			
			if(jQuery('#registered_user').html()!=''){
				setTimeout('loadRestoreList()',1000);
				<?php if($machine=='twotier') { ?>
				if (machine == 'twotier') {
					$('.update-btn').show();
					$('.update-btn>a').click(function() {
						$('#page_loader').show();
						showErrorMessages('.alert','Updating...');
					});
				}
				<?php } ?>
			} else if (machine == 'twotier') $('.update-btn').hide();
			
		});
	
	</script>
	<script type="text/javascript">
	<?php
		$now = exec('date "+%Y-%m-%d %H:%M:%S"');
		try {
			$now = new DateTime($now);
		} catch(Exception $e) {}
		
		echo sprintf("var serverDate = new Date('%s');\n", ($now->format("F d, Y H:i:s")));
	?>
	function format(type, value) {
		switch(type) {
			case 'month': var months=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
			return months[value];
			case 'day': var days=["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
			return days[value];
		}
	}

	setInterval( function() {
		serverDate.setSeconds(serverDate.getSeconds()+1)

		var seconds = serverDate.getSeconds();
		var sdegree = seconds * 6;
		var srotate = "rotate(" + sdegree + "deg)";
		$("#sec").css({"-moz-transform" : srotate, "-webkit-transform" : srotate});

		var mins = serverDate.getMinutes();
		var mdegree = mins * 6;
		var mrotate = "rotate(" + mdegree + "deg)";
		$("#min").css({"-moz-transform" : mrotate, "-webkit-transform" : mrotate});

		var hours = serverDate.getHours();
		var mins = serverDate.getMinutes();
		var hdegree = hours * 30 + (mins / 2);
		var hrotate = "rotate(" + hdegree + "deg)";              
		$("#hour").css({"-moz-transform" : hrotate, "-webkit-transform" : hrotate});

		var day = format('day', serverDate.getDay());
		var month = format('month', serverDate.getMonth());
		var date = serverDate.getDate();
		var year = serverDate.getFullYear();
		var meridiem = ((hours < 12) ? "AM" : "PM");
		// hours = (hours % 12);
		hours = ((hours > 12)? (hours - 12) : hours);
		hours = ((hours < 10) ? ('0' + hours) : hours)
		mins = ((mins < 10) ? ('0' + mins) : mins);

		$('.container-time-wrap .hours-disp').text(hours);
		$('.container-time-wrap .minutes-disp').text(mins);
		$('.container-time-wrap .meridiem-disp').text(meridiem);

		$('.container-time-wrap .day-disp').text(day);
		$('.container-time-wrap .month-disp').text(month);
		$('.container-time-wrap .date-disp').text(date);
		$('.container-time-wrap .year-disp').text(year);
	}, 1000 );

$('.device-time-wrap').click( function() {
	var toggleWidth = $(".time-innerwrap").width() == 240 ? "0px" : "240px";
	$('.time-innerwrap').animate({ width: toggleWidth });
	$('.device-time-wrap').css('width','auto');
	$('.device-time-wrap').toggleClass('device-time-wrap-w');
	$('.device-time-wrap div.time-arrow a.slide-arrow-close').toggleClass('slide-arrow-open'); 
});
</script>
</body>
</html>
